#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <string>
#include <vector>
#include <iostream>
#include <memory>
#include <functional>
using namespace std;
#pragma comment(lib,"ws2_32.lib")
#pragma comment(lib,"winmm.lib")
#pragma comment(linker,"\"/manifestdependency:type='win32' \
name='Microsoft.Windows.Common-Controls' version='6.0.0.0' \
processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")


// Helper to call DLL functions
template <typename R, typename... Args>
R DLLCall(HMODULE hModule, const char* procname, Args... args)
	{
	FARPROC fp = GetProcAddress(hModule, procname);
	if (!fp)
		throw E_POINTER;
	typedef R(__stdcall * function_pointer)(Args...);
	function_pointer P = (function_pointer)fp;
	const auto return_value = (*P)(std::forward<Args>(args)...);
	return return_value;
	}

// Main
int main(int argc,char** argv)
	{
	WSADATA wData;
	WSAStartup(MAKEWORD(2, 2), &wData);
	// COM initialization
	CoInitializeEx(0, COINIT_APARTMENTTHREADED);

	// Load the DLL
#ifdef _WIN64
	HINSTANCE hDLL = LoadLibrary(L"hmn64.dll");
#else
	HINSTANCE hDLL = LoadLibrary(L"hmn32.dll");
#endif
	if (!hDLL)
		{
		std::cout << "Error, HMN DLL cannot be found." << endl;
		return 0;
		}

	// Get ports to use
	HICON hIcon = LoadIcon(0, IDI_QUESTION);
	string host;

	if (argc >= 2)
		host = argv[1];
	else
		{
		std::cout << "Enter host: ";
		std::cin >> host;
		}
	if (host.empty())
		{
		host = "127.0.0.1";
		}
	unsigned short Port1 = 7004;
	if (argc >= 2)
		Port1 = (unsigned short)atoi(argv[2]);
	else
		{
		std::cout << "Enter negotiation port: ";
		std::cin >> Port1;
		}



	// Try the server
	auto rs = DLLCall<HRESULT, 
		HWND,
		HICON, 
		const char*,
		unsigned short,
		const wchar_t*,
		bool>(
		hDLL, "IWantHelp", nullptr,hIcon, host.c_str(),Port1,L"Jack Hopeless",true);
	if (FAILED(rs))
		std::cout << "Operation failed." << endl;
	else
		std::cout << "Operation completed." << endl;

	// Free
	FreeLibrary(hDLL);
	return 0;
	}
